(function () {
    "use strict";

    angular.module('core').controller('usuarioController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$stateParams', '$alert', 'usuarioService', 'lookupService'];

    function controller($scope, $timeout, $q, $stateParams, $alert, usuarioService, lookupService) {
        $scope.initializeLayout('Usuários');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: { Ativo: true },
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };
        $scope.popups = {
            /* add a entidade é Usuario. */
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                    usuarioService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $scope.refresh();

                                    if (action === $scope.popups.add.saveAction.saveAndNew) {
                                        $scope.popups.add.steps.index = 0;
                                        $scope.popups.add.toggle();
                                    }
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                saveAction: { save: 0, saveAndNew: 1 },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepareNew();
                    }
                    else {
                        $scope.popups.add.steps.index = 0;
                    }
                },
                prepareNew: function () {
                    usuarioService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.add.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ativo = true;
                                    $timeout(function () { $('[ng-model*="popups.add.data.Nome"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.popups.add.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepareNewMembro: function () {
                    var args = {
                        item: $scope.popups.add.data,
                        grupoUsuario: $scope.popups.add.ingressarGrupo
                    };
                    usuarioService
                        .prepareNewMembro(args)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ingressarGrupo = null;
                                    $timeout(function () { $('[ng-model*="popups.add.ingressarGrupo"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepare: function () {
                    usuarioService
                        .prepare($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $timeout(function () { $('[ng-model*="popups.add.data.Nome"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                steps: {
                    index: 0,
                    count: 2,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                },
            },
            /* edit a entidade é Usuario. */
            edit: {
                ativo: false,
                data: {},
                toggle: function (id) {
                    $scope.popups.edit.ativo = !$scope.popups.edit.ativo;
                    if ($scope.popups.edit.ativo && id) {
                        $scope.popups.edit.get(id);
                    }
                },
                get: function (id) {
                    $scope.state.salvando = true;
                    usuarioService
                        .get({ id: id })
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                    $scope.popups.edit.ativo = false;
                                } else {
                                    $scope.popups.edit.data = response.Data;
                                    $scope.popups.edit.ativo = true;
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.popups.edit.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                save: function () {
                    $scope.state.salvando = true;
                    usuarioService
                        .save($scope.popups.edit.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.popups.edit.ativo = false;
                                    $scope.popups.edit.data = {};
                                    $scope.refresh();
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                delete: function (id) {
                    $scope.state.salvando = true;
                    usuarioService
                        .delete(id ? id : $scope.popups.edit.data.ID)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.popups.edit.ativo = false;
                                    $scope.popups.edit.data = {};
                                    $scope.refresh();
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepare: function () {
                    usuarioService
                        .prepare($scope.popups.edit.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.popups.edit.data = response.Data;
                                    $scope.popups.edit.ativo = true;
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepareNewMembro: function () {
                    var args = {    
                        item: $scope.popups.edit.data,
                        grupoUsuario: $scope.popups.edit.ingressarGrupo
                    };
                    usuarioService
                        .prepareNewMembro(args)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.popups.edit.data = response.Data;
                                    $scope.popups.edit.ingressarGrupo = null;
                                    $timeout(function () { $('[ng-model*="popups.edit.ingressarGrupo"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
            },
            webcam: {
                ativo: false,
                processando: false,

                patOpts: { x: 0, y: 0, w: 25, h: 25 },
                channel: {},
                webcamError: false,
                snapshotData: null,
                _video: null,
                patData: null,

                onError: function (err) {
                    $scope.$apply(
                        function () {
                            $scope.popups.webcam.webcamError = err;
                        }
                    );
                },
                onSuccess: function () {
                    // The video element contains the captured camera data
                    $scope.popups.webcam._video = $scope.popups.webcam.channel.video;
                    $scope.$apply(function () {
                        $scope.popups.webcam.patOpts.w = $scope.popups.webcam._video.width;
                        $scope.popups.webcam.patOpts.h = $scope.popups.webcam._video.height;
                        //$scope.showDemos = true;
                    });
                },
                onStream: function (stream) {
                    // You could do something manually with the stream.
                },
                makeSnapshot: function () {
                    if ($scope.popups.webcam._video) {
                        var patCanvas = document.querySelector('#snapshot');
                        if (!patCanvas) return;

                        patCanvas.width = $scope.popups.webcam._video.width;
                        patCanvas.height = $scope.popups.webcam._video.height;
                        var ctxPat = patCanvas.getContext('2d');

                        var idata = $scope.popups.webcam.getVideoData($scope.popups.webcam.patOpts.x, $scope.popups.webcam.patOpts.y, $scope.popups.webcam.patOpts.w, $scope.popups.webcam.patOpts.h);
                        ctxPat.putImageData(idata, 0, 0);

                        $scope.popups.webcam.sendSnapshotToServer(patCanvas.toDataURL());

                        patData = idata;
                    }
                },
                downloadSnapshot: function downloadSnapshot(dataURL) {
                    window.location.href = dataURL;
                },
                getVideoData: function getVideoData(x, y, w, h) {
                    var hiddenCanvas = document.createElement('canvas');
                    hiddenCanvas.width = $scope.popups.webcam._video.width;
                    hiddenCanvas.height = $scope.popups.webcam._video.height;
                    var ctx = hiddenCanvas.getContext('2d');
                    ctx.drawImage($scope.popups.webcam._video, 0, 0, $scope.popups.webcam._video.width, $scope.popups.webcam._video.height);
                    return ctx.getImageData(x, y, w, h);
                },
                sendSnapshotToServer: function sendSnapshotToServer(imgBase64) {
                    $scope.popups.webcam.snapshotData = imgBase64;
                },

                toggle: function () {
                    $scope.popups.webcam.ativo = !$scope.popups.webcam.ativo;
                },
                confirm: function () {
                    /*TODO: implementar confirmação da foto. */
                    $scope.popups.webcam.ativo = !$scope.popups.webcam.ativo;
                }
            }
        };
        $scope.auxiliar = {
            grupoUsuario: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoUsuario({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            usuarioService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            usuarioService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            if ($scope.state.carregandoMais)
                return;

            $scope.state.carregandoMais = true;
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            usuarioService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                        $scope.state.carregandoMais = false;
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                        $scope.state.carregandoMais = false;
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.filtro.Ativo = null;

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();